/*************************************************************************************************
*                        
*        ģ:̴߳ͨѶ        
*        :liu_sir    :2003.4.20 -4.30       
*        汾:v1.0 
*        Ҫ˵:
*             CComPort   ھۺһCSerialPortڴڵĲ
*                      ģʽ˵:
*   	                 1.ManualReceiveByQuery,  //ֶѯ
*		                 2.ManualReceiveByConst,  //(һ)
*		                 3.AutoReceiveBySignal,   //źԶ
*                        4.AutoReceiveByBreak,	   //ԶжϽ
*                     Ƽʹ:13
*		     CReadComThread ڶ߳  CComPortв
*       
*
***************************************************************************************************/
#pragma once
//պ
#ifndef COMPORT_H
#define COMPORT_H

typedef void (* FOnReceiveData)(LPVOID,void*,DWORD);
typedef void (* FOnComBreak)(LPVOID,DWORD,COMSTAT stat);


#include "serialport.h"
// CComPort Ŀ
namespace LsComm{

class CReadComThread;

class CComPort 
{
public:
	enum ReceiveMode
	{
		ManualReceiveByQuery,  //ֶѯ
		ManualReceiveByConst,  //
		AutoReceiveBySignal,   //źԶ
        AutoReceiveByBreak,	   //ԶжϽ
	};
    //Enums
	enum FlowControl
	{
		NoFlowControl,
		CtsRtsFlowControl,
		CtsDtrFlowControl,
		DsrRtsFlowControl,
		DsrDtrFlowControl,
		XonXoffFlowControl
	};

	enum Parity
	{    
		EvenParity,
		MarkParity,
		NoParity,
		OddParity,
		SpaceParity
	};

	enum StopBits
	{
		OneStopBit,
		OnePointFiveStopBits,
		TwoStopBits
	};

	CComPort();
	virtual ~CComPort();


	  //1.,رմں
	  void Open(int nPort,ReceiveMode mode=AutoReceiveBySignal, DWORD dwBaud = 9600, Parity parity = NoParity, BYTE DataBits = 8, 
		  StopBits stopbits = OneStopBit, FlowControl fc = NoFlowControl);
      void Close();

      //2.ýպ,жϴ 
	  void SetReceiveFunc(FOnReceiveData pfnOnReceiveData,LPVOID pSender);
      void SetBreakHandleFunc(FOnComBreak pfnOnComBreak);

	  //3.ȡ
	  int GetCurPortNum() { return this->m_CurPortNum;  }
	  CSerialPort* GetSerialPort(); 
	  HANDLE GetCloseHandle();
	  ReceiveMode GetReceiveMode();

      //4.(߳)֪ͨմ     
	  void ReceiveData(void* pBuf,DWORD InBufferCount);//̵߳õĽպ
	  void ComBreak(DWORD dwMask);

	  //6.,--ʵʸ
	  DWORD GetInBufferCount();
	  DWORD GetInput(void* pBuf,DWORD Count,DWORD dwMilliseconds=1000);
	  DWORD Output(void* pBuf,DWORD Count);
	  bool IsOverlapped() { return m_IsOverlapped; }
protected:
	CSerialPort* m_pPort;                           //ں
	CReadComThread* m_pReadThread;                  //߳ 

	LPVOID m_pSender;                               //ĸָ
	int m_CurPortNum;                               //ǰ˿ں 
    FOnReceiveData m_pfnOnReceiveData;              //źź
	FOnComBreak    m_pfnOnComBreak;                 //¼
    ReceiveMode    m_RecvMode;                      //ģʽ

	HANDLE         m_hWriteEvent;                    //д¼
	OVERLAPPED     m_WriteOverlapped;                //дصṹ

	bool m_IsOverlapped;                            //Ƿصṹ;
private:
    HANDLE m_hCloseEvent; //E: A event handle to close thread  //Chinese:߳¼

};

DWORD WINAPI ThreadFunc(LPVOID  lpParam ); //̵߳ú 

class CReadComThread
{
public:
    /*1.ϵ
	*/
	CReadComThread();
    virtual ~CReadComThread();          
    
	/* 2.,,λ 
	*/
    void Create();                         //߳
    void Terminate();                      //߳
    void Resume();                         //λ 
	bool IsTerminated()	{return this->m_IsTerminated; }
     
	/*3.󶨴,첽ȡ
	*/
	void BandSerialPort(CComPort* pPort);  //󶨴
	DWORD ReadInput(void* pBuf,DWORD Count,DWORD dwMilliseconds);//첽ȡ

	friend DWORD WINAPI ThreadFunc(LPVOID  lpParam ); 
protected:
	DWORD dwThreadId;//̺߳  
    bool IsClose;
    /*4.첽ȡ¼,첽ж¼Լ¼
	*/
	bool SetReadEvent(OVERLAPPED& overlapped);//¼
	bool HandleReadEvent(OVERLAPPED& overlapped);//¼
    bool HandleData(); //ȡ
    
	bool SetBreakEvent(DWORD& dwMask);//ôж¼,ͨDWMaskĸı䷵ؼ״̬
	bool HandleBreakEvent(DWORD dwMask);//ж¼

	/*5.ֶģʽ,źģʽ,жģʽִ߳
	*/
	void ExecuteByAutoSignalRecvMode();
	void ExecuteByAutoBreakRecvMode();
	void ExecuteByManualQueryRecvMode();
	void ExecuteByManualConstRecvMode();
    void Execute(void);                    //ִ߳
   
private:
	HANDLE m_hThread;           //߳̾
	CComPort* m_pPort;          //ָ

    byte  m_InputBuffer[2048];  //ջ
	byte* m_pBuffer;            //ʵʵڴ 
	DWORD m_InBufferCount;      //ո 

	OVERLAPPED m_ReadOverlapped;     //ȡصṹ
	OVERLAPPED m_BreakOverlapped;    //ж¼ṹ
    
	bool m_IsTerminated;            //Ƿ߳ 

};

}

#endif